/*
 *
 *  ebmini
 *  ŻҽҸץ
 *
 *
 *  Copyright (c) 2005-2007  Kiichiro Kawano <k-kawano@mail.707.to>
 *
 *
 *  License : The GNU General Public License, Version 2 or later
 *  See the GNU General Public License for more details.
 *
 *  ebminiϡGPLGNU General Public Licenseˤ˴Ťۤ
 *  եȥǤС2뤤ϤʹߤǤդΥС
 *  GPLˤäơۤѤ򤹤뤳ȤǤޤ
 *
 *  ΥեȥͭѤ̤Ф뤳ȤԤƸΤǤ
 *  ޤˤäƤϤʤݾڤ⤪ʤޤ󡣾ܤϡ
 *  ѥå°GNU General Public Licenseɤߤ
 *
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include <eb/eb.h>
#include <eb/error.h>
#include <eb/text.h>

#include <iconv.h>


/*
 *
 *. 
 *
 */

typedef	int		BOOL;
#define	FALSE	0
#define	TRUE	(!FALSE)

#define	MAX(a, b)	((a) > (b) ? (a) : (b))

#define	MAX_PATH_SIZE					256
#define	MAX_PATH_WORK_SIZE				(MAX_PATH_SIZE + 16)

#define	MAX_PARA_SIZE					8192

#define	ENC_INVALID						-1
#define	ENC_EUCJP						0
#define	ENC_SHIFTJIS					1
#define	ENC_UTF8						2

#define	SET_ENC_INPUT					TRUE
#define	SET_ENC_OUTPUT					FALSE

#define	METHOD_INVALID					-1
#define	METHOD_WORD						0
#define	METHOD_ENDWORD					1
#define	METHOD_KEYWORD					2
#define	METHOD_CROSS					3
#define	METHOD_LINK						4
#define	METHOD_MENU						5
#define	METHOD_COPYRIGHT				6

#define	MAX_METHOD						7

#define	TEXT_VIEW_NORMAL				-1

#define	MAX_SEARCH_WORD					15
#define	MAX_HIT_ENTRIES					1024
#define	MAX_BUFFER_SIZE					65536

#define	DATAOUT_TEXT					TRUE
#define	DATAOUT_HEADING					FALSE

#define	DATAOUT_CROSS_HEADING_AND_TEXT	TRUE
#define	DATAOUT_CROSS_HEADING_ONLY		FALSE

/*
 *.. եޥåʸ
 */

#define	FMT_BOOK_START_LENGTH			256
#define	FMT_BOOK_START_ARGS				0

#define	FMT_METHOD_START_LENGTH			256
#define	FMT_METHOD_START_ARGS			0

#define	FMT_METHOD_START_PTR(i)			\
(g_fmt_method_start + FMT_METHOD_START_LENGTH * (i))

#define	FMT_TEXT_ITEM_START_LENGTH		256
#define	FMT_TEXT_ITEM_START_ARGS		0

#define	FMT_TEXT_ITEM_END_LENGTH		256
#define	FMT_TEXT_ITEM_END_ARGS			0

#define	FMT_LIST_START_LENGTH			256
#define	FMT_LIST_START_ARGS				0

#define	FMT_LIST_ITEM_START_LENGTH		256
#define	FMT_LIST_ITEM_START_ARGS		2

#define	FMT_LIST_ITEM_END_LENGTH		256
#define	FMT_LIST_ITEM_END_ARGS			2

#define	FMT_LIST_END_LENGTH				256
#define	FMT_LIST_END_ARGS				0

#define	FMT_BOOK_END_LENGTH				256
#define	FMT_BOOK_END_ARGS				0

#define	FMT_INDENT_LENGTH				256
#define	FMT_INDENT_ARGS					0

#define	MAX_FMT_INDENT					8

#define	FMT_INDENT_PTR(i)				\
(g_fmt_indent + FMT_INDENT_LENGTH * (i))

#define	FMT_BEGIN_REFERENCE_LENGTH		256
#define	FMT_BEGIN_REFERENCE_ARGS		0

#define	FMT_END_REFERENCE_LENGTH		256
#define	FMT_END_REFERENCE_ARGS			2

#define	FMT_BEGIN_SUBSCRIPT_LENGTH		256
#define	FMT_BEGIN_SUBSCRIPT_ARGS		0

#define	FMT_END_SUBSCRIPT_LENGTH		256
#define	FMT_END_SUBSCRIPT_ARGS			0

#define	FMT_BEGIN_SUPERSCRIPT_LENGTH	256
#define	FMT_BEGIN_SUPERSCRIPT_ARGS		0

#define	FMT_END_SUPERSCRIPT_LENGTH		256
#define	FMT_END_SUPERSCRIPT_ARGS		0

#define	FMT_BEGIN_CANDIDATE_LENGTH		256
#define	FMT_BEGIN_CANDIDATE_ARGS		0

#define	FMT_END_CANDIDATE_LEAF_LENGTH	256
#define	FMT_END_CANDIDATE_LEAF_ARGS		0

#define	FMT_END_CANDIDATE_GROUP_LENGTH	256
#define	FMT_END_CANDIDATE_GROUP_ARGS	2

#define	FMT_BEGIN_EMPHASIS_LENGTH		256
#define	FMT_BEGIN_EMPHASIS_ARGS			0

#define	FMT_END_EMPHASIS_LENGTH			256
#define	FMT_END_EMPHASIS_ARGS			0

#define	FMT_BEGIN_KEYWORD_LENGTH		256
#define	FMT_BEGIN_KEYWORD_ARGS			0

#define	FMT_END_KEYWORD_LENGTH			256
#define	FMT_END_KEYWORD_ARGS			0

#define	FMT_BEGIN_DECORATION_LENGTH		256
#define	FMT_BEGIN_DECORATION_ARGS		0

#define	FMT_END_DECORATION_LENGTH		256
#define	FMT_END_DECORATION_ARGS			0

#define	FMT_NEWLINE_LENGTH				256
#define	FMT_NEWLINE_ARGS				0

#define	FMT_GAIJI_FULL_DEFAULT_LENGTH	256
#define	FMT_GAIJI_FULL_DEFAULT_ARGS		1

#define	FMT_GAIJI_HALF_DEFAULT_LENGTH	256
#define	FMT_GAIJI_HALF_DEFAULT_ARGS		1

/*
 *.. 
 */

#define	MAX_GAIJI_LENGTH				32
#define	MAX_GAIJI_ARGS					0
#define	MAX_GAIJI_NUMBER				((0x7e - 0x21 + 1) * (0xfe - 0xa1 + 1))

#define	GAIJI_FULL_PTR(b1, b2)			\
(g_gaiji_full_buffer + MAX_GAIJI_LENGTH * ((0x7e - 0x21 + 1) * ((b1) - 0xa1) + ((b2) - 0x21)))
#define	GAIJI_HALF_PTR(b1, b2)			\
(g_gaiji_half_buffer + MAX_GAIJI_LENGTH * ((0x7e - 0x21 + 1) * ((b1) - 0xa1) + ((b2) - 0x21)))


/*
 *
 *. Хѿ
 *
 */

char		g_output_file_path[MAX_PATH_SIZE];
FILE		*g_output_file;

char		g_book_path[MAX_PATH_SIZE];
int			g_subbook_number = 1;

const char	*g_encoding_table[] = { "EUC-JP", "Shift_JIS", "UTF-8", NULL };
const char	g_encoding_short[] = "esu";
int			g_input_encoding = ENC_EUCJP;
int			g_output_encoding = ENC_EUCJP;

const char	*g_method_table[] = { "word", "endword", "keyword", "cross", "link", "menu", "copyright", NULL };
const char	g_method_short[] = "wekclMC";
int			g_search_method[MAX_METHOD] = { METHOD_WORD };
int			g_search_method_count = 1;
BOOL		g_enable_fmt_method_start = TRUE;

int			g_text_view = TEXT_VIEW_NORMAL;
int			g_list_view = 20;

char		*g_search_word_ptr[MAX_SEARCH_WORD + 1] = { NULL };
int			g_search_word_count = 0;
int			g_search_word_buffer_size = 0;

EB_Book		g_book_object;
BOOL		g_book_object_opend = FALSE;

EB_Hookset	g_hookset_object;
BOOL		g_hookset_object_opened = FALSE;

iconv_t		g_input_cd;
BOOL		g_input_cd_opened = FALSE;
iconv_t		g_output_cd;
BOOL		g_output_cd_opened = FALSE;

/*
 *.. եޥåʸ
 */

char		g_fmt_book_start[FMT_BOOK_START_LENGTH];
char		g_fmt_method_start[FMT_METHOD_START_LENGTH * MAX_METHOD];
char		g_fmt_text_item_start[FMT_TEXT_ITEM_START_LENGTH];
char		g_fmt_text_item_end[FMT_TEXT_ITEM_END_LENGTH];
char		g_fmt_list_start[FMT_LIST_START_LENGTH];
char		g_fmt_list_item_start[FMT_LIST_ITEM_START_LENGTH];
char		g_fmt_list_item_end[FMT_LIST_ITEM_END_LENGTH];
char		g_fmt_list_end[FMT_LIST_END_LENGTH];
char		g_fmt_book_end[FMT_BOOK_END_LENGTH];

char		g_fmt_indent[FMT_INDENT_LENGTH * MAX_FMT_INDENT];
char		g_fmt_begin_reference[FMT_BEGIN_REFERENCE_LENGTH];
char		g_fmt_end_reference[FMT_END_REFERENCE_LENGTH];
char		g_fmt_begin_subscript[FMT_BEGIN_SUBSCRIPT_LENGTH];
char		g_fmt_end_subscript[FMT_END_SUBSCRIPT_LENGTH];
char		g_fmt_begin_superscript[FMT_BEGIN_SUPERSCRIPT_LENGTH];
char		g_fmt_end_superscript[FMT_END_SUPERSCRIPT_LENGTH];
char		g_fmt_begin_candidate[FMT_BEGIN_CANDIDATE_LENGTH];
char		g_fmt_end_candidate_leaf[FMT_END_CANDIDATE_LEAF_LENGTH];
char		g_fmt_end_candidate_group[FMT_END_CANDIDATE_GROUP_LENGTH];
char		g_fmt_begin_emphasis[FMT_BEGIN_EMPHASIS_LENGTH];
char		g_fmt_end_emphasis[FMT_END_EMPHASIS_LENGTH];
char		g_fmt_begin_keyword[FMT_BEGIN_KEYWORD_LENGTH];
char		g_fmt_end_keyword[FMT_END_KEYWORD_LENGTH];
char		g_fmt_begin_decoration[FMT_BEGIN_DECORATION_LENGTH];
char		g_fmt_end_decoration[FMT_END_DECORATION_LENGTH];
char		g_fmt_newline[FMT_NEWLINE_LENGTH];
char		g_fmt_gaiji_full_default[FMT_GAIJI_FULL_DEFAULT_LENGTH];
char		g_fmt_gaiji_half_default[FMT_GAIJI_HALF_DEFAULT_LENGTH];

/*
 *.. ʸХåե
 */

char		g_gaiji_full_buffer[MAX_GAIJI_LENGTH * MAX_GAIJI_NUMBER];
char		g_gaiji_half_buffer[MAX_GAIJI_LENGTH * MAX_GAIJI_NUMBER];

/*
 *.. ü쥪ץ
 */

BOOL		g_enable_config_display = FALSE;		/* -x0[+|-] */
BOOL		g_enable_utf8_ex_conv = TRUE;		/* -x1[+|-] */


/*
 *
 *. ִؿ
 *
 */

/*
 *.. ե뤫ΰ
 *   size-1Хɤ߹ߡʹߤڤΤƤ
 */
char	*get_para(char *para, int size, FILE *stream)
{
	char	*result;
	char	*p;
	char	buf[MAX_BUFFER_SIZE];

	result = fgets(para, size, stream);
	if (result != NULL) {
		p = para + strlen(para) - 1;
		if (*p == '\n') {
			*p = '\0';
		}
		else {
			for (;;) {
				if (fgets(buf, sizeof(buf), stream) == NULL)
					break;
				p = buf + strlen(buf) - 1;
				if (*p == '\n')
					break;
			}
		}
	}
	return result;
}

/*
 *.. ʸƬζʸ򥹥å
 */
char	*get_word_top(char *str)
{
	while (isspace(*str))
		++str;
	return str;
}

/*
 *.. ʸζʸ
 */
void	remove_trailing_space(char *str)
{
	char	*p;

	p = str + strlen(str);
	while (str < p) {
		if (!isspace(*(p - 1)))
			break;
		--p;
	}
	*p = '\0';
}


/*
 *
 *. եåؿ
 *
 */

/*
 *.. EUC-JPʸ󥳡ǥ󥰤ؤѴ
 */
EB_Error_Code	hook_euc_to_output_encoding(EB_Book *book, EB_Appendix *appendix,
	void *container, EB_Hook_Code code, int argc, const unsigned int *argv)
{
	int			in_code1, in_code2;
	char		input_buffer[16];
	char		output_buffer[16];
	const char	*inbuf_ptr;
	char		*outbuf_ptr;
	size_t		inbytesleft;
	size_t		outbytesleft;

    in_code1 = argv[0] >> 8;
    in_code2 = argv[0] & 0xff;

	if (g_output_encoding == ENC_EUCJP) {
		eb_write_text_byte2(book, in_code1, in_code2);
		return EB_SUCCESS;
	}

	/* -x1 ץ */
	/* libiconv̤ʸľUTF-8Ѵ */
	if (g_output_encoding == ENC_UTF8 && g_enable_utf8_ex_conv == TRUE) {
		/* JIS0x2141ȷʸ''EUC-JP󥳡ɻ0xa1c1ˤ */
		/* UnicodeU+FF5E Fullwidth TildeUTF-8󥳡ɻ0xefbd9eˤѴ */
		if (in_code1 == 0xa1 && in_code2 == 0xc1) {
			eb_write_text_string(book, "\xef\xbd\x9e");
			return EB_SUCCESS;
		}
	}

	input_buffer[0] = in_code1;
	input_buffer[1] = in_code2;
	inbuf_ptr = input_buffer;
	outbuf_ptr = output_buffer;
	inbytesleft = 2;
	outbytesleft = sizeof(output_buffer) - 1;
	iconv(g_output_cd, &inbuf_ptr, &inbytesleft, &outbuf_ptr, &outbytesleft);
	*outbuf_ptr = '\0';
	eb_write_text_string(book, output_buffer);

	return EB_SUCCESS;
}

/*
 *.. EUC-JPASCIIؤѴ
 *   EB Libraryeb_hook_euc_to_ascii()ؿư¿ѹ
 */

/*   ꥸʥǤ饤󥹾by޸Ƿ  */
/*
 * Copyright (c) 1997-2006  Motoyuki Kasahara
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the project nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE PROJECT OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#define	EUC_TO_ASCII_TABLE_START	0xa0
#define	EUC_TO_ASCII_TABLE_END		0xff

static const unsigned char euc_a1_to_ascii_table[] = {
	0x00, 0x20, 0x00, 0x00, 0x2c, 0x2e, 0x00, 0x3a,		/* 0xa0 */
	0x3b, 0x3f, 0x21, 0x00, 0x00, 0x00, 0x60, 0x00,		/* 0xa8 */
	0x5e, 0x7e, 0x5f, 0x00, 0x00, 0x00, 0x00, 0x00,		/* 0xb0 */
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x2d, 0x2f,		/* 0xb8 */
	0x5c, 0x00, 0x00, 0x7c, 0x00, 0x00, 0x00, 0x27,		/* 0xc0 */
	0x00, 0x22, 0x28, 0x29, 0x00, 0x00, 0x5b, 0x5d,		/* 0xc8 */
	0x7b, 0x7d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,		/* 0xd0 */
	0x00, 0x00, 0x00, 0x00, 0x2b, 0x2d, 0x00, 0x00,		/* 0xd8 */
	0x00, 0x3d, 0x00, 0x3c, 0x3e, 0x00, 0x00, 0x00,		/* 0xe0 */
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x5c,		/* 0xe8 */
	0x24, 0x00, 0x00, 0x25, 0x23, 0x26, 0x2a, 0x40,		/* 0xf0 */
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,		/* 0xf8 */
};

static const unsigned char euc_a3_to_ascii_table[] = {
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,		/* 0xa0 */
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,		/* 0xa8 */
	0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37,		/* 0xb0 */
	0x38, 0x39, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,		/* 0xb8 */
	0x00, 0x41, 0x42, 0x43, 0x44, 0x45, 0x46, 0x47,		/* 0xc0 */
	0x48, 0x49, 0x4a, 0x4b, 0x4c, 0x4d, 0x4e, 0x4f,		/* 0xc8 */
	0x50, 0x51, 0x52, 0x53, 0x54, 0x55, 0x56, 0x57,		/* 0xd0 */
	0x58, 0x59, 0x5a, 0x00, 0x00, 0x00, 0x00, 0x00,		/* 0xd8 */
	0x00, 0x61, 0x62, 0x63, 0x64, 0x65, 0x66, 0x67,		/* 0xe0 */
	0x68, 0x69, 0x6a, 0x6b, 0x6c, 0x6d, 0x6e, 0x6f,		/* 0xe8 */
	0x70, 0x71, 0x72, 0x73, 0x74, 0x75, 0x76, 0x77,		/* 0xf0 */
	0x78, 0x79, 0x7a, 0x00, 0x00, 0x00, 0x00, 0x00,		/* 0xf8 */
};

EB_Error_Code	hook_euc_to_ascii(EB_Book *book, EB_Appendix *appendix,
	void *container, EB_Hook_Code code, int argc, const unsigned int *argv)
{
	int		in_code1, in_code2;
	int		out_code = 0;

	in_code1 = argv[0] >> 8;
	in_code2 = argv[0] & 0xff;

	if (in_code2 < EUC_TO_ASCII_TABLE_START || EUC_TO_ASCII_TABLE_END < in_code2) {
		out_code = 0;
	}
	else if (in_code1 == 0xa1) {
		out_code = euc_a1_to_ascii_table[in_code2 - EUC_TO_ASCII_TABLE_START];
	}
	else if (in_code1 == 0xa3) {
		out_code = euc_a3_to_ascii_table[in_code2 - EUC_TO_ASCII_TABLE_START];
	}

	if (out_code != 0)
		eb_write_text_byte1(book, out_code);
	else
		hook_euc_to_output_encoding(book, appendix, container, code, argc, argv);

	return EB_SUCCESS;
}

/*
 *.. ǥ
 */
EB_Error_Code	hook_set_indent(EB_Book *book, EB_Appendix *appendix,
	void *container, EB_Hook_Code code, int argc, const unsigned int *argv)
{
	char	*p;
	char	buf[FMT_INDENT_LENGTH + 64];

	if (argv[1] < MAX_FMT_INDENT) {
		p = FMT_INDENT_PTR(argv[1]);
		if (*p != '\0') {
			snprintf(buf, sizeof(buf), p);
			eb_write_text_string(book, buf);
		}
	}

	return EB_SUCCESS;
}

/*
 *.. ե
 */
EB_Error_Code	hook_begin_reference(EB_Book *book, EB_Appendix *appendix,
	void *container, EB_Hook_Code code, int argc, const unsigned int *argv)
{
	char	buf[FMT_BEGIN_REFERENCE_LENGTH + 64];

	if (g_fmt_begin_reference[0] != '\0') {
		snprintf(buf, sizeof(buf), g_fmt_begin_reference);
		eb_write_text_string(book, buf);
	}

	return EB_SUCCESS;
}

EB_Error_Code	hook_end_reference(EB_Book *book, EB_Appendix *appendix,
	void *container, EB_Hook_Code code, int argc, const unsigned int *argv)
{
	char	buf[FMT_END_REFERENCE_LENGTH + 64];

	if (g_fmt_end_reference[0] != '\0') {
		snprintf(buf, sizeof(buf), g_fmt_end_reference, argv[1], argv[2]);
		eb_write_text_string(book, buf);
	}

	return EB_SUCCESS;
}

/*
 *.. դ
 */
EB_Error_Code	hook_begin_subscript(EB_Book *book, EB_Appendix *appendix,
	void *container, EB_Hook_Code code, int argc, const unsigned int *argv)
{
	char	buf[FMT_BEGIN_SUBSCRIPT_LENGTH + 64];

	if (g_fmt_begin_subscript[0] != '\0') {
		snprintf(buf, sizeof(buf), g_fmt_begin_subscript);
		eb_write_text_string(book, buf);
	}

	return EB_SUCCESS;
}

EB_Error_Code	hook_end_subscript(EB_Book *book, EB_Appendix *appendix,
	void *container, EB_Hook_Code code, int argc, const unsigned int *argv)
{
	char	buf[FMT_END_SUBSCRIPT_LENGTH + 64];

	if (g_fmt_end_subscript[0] != '\0') {
		snprintf(buf, sizeof(buf), g_fmt_end_subscript);
		eb_write_text_string(book, buf);
	}

	return EB_SUCCESS;
}

/*
 *.. դ
 */
EB_Error_Code	hook_begin_superscript(EB_Book *book, EB_Appendix *appendix,
	void *container, EB_Hook_Code code, int argc, const unsigned int *argv)
{
	char	buf[FMT_BEGIN_SUPERSCRIPT_LENGTH + 64];

	if (g_fmt_begin_superscript[0] != '\0') {
		snprintf(buf, sizeof(buf), g_fmt_begin_superscript);
		eb_write_text_string(book, buf);
	}

	return EB_SUCCESS;
}

EB_Error_Code	hook_end_superscript(EB_Book *book, EB_Appendix *appendix,
	void *container, EB_Hook_Code code, int argc, const unsigned int *argv)
{
	char	buf[FMT_END_SUPERSCRIPT_LENGTH + 64];

	if (g_fmt_end_superscript[0] != '\0') {
		snprintf(buf, sizeof(buf), g_fmt_end_superscript);
		eb_write_text_string(book, buf);
	}

	return EB_SUCCESS;
}

/*
 *.. ʣ縡θ
 */
EB_Error_Code	hook_begin_candidate(EB_Book *book, EB_Appendix *appendix,
	void *container, EB_Hook_Code code, int argc, const unsigned int *argv)
{
	char	buf[FMT_BEGIN_CANDIDATE_LENGTH + 64];

	if (g_fmt_begin_candidate[0] != '\0') {
		snprintf(buf, sizeof(buf), g_fmt_begin_candidate);
		eb_write_text_string(book, buf);
	}

	return EB_SUCCESS;
}

EB_Error_Code	hook_end_candidate_leaf(EB_Book *book, EB_Appendix *appendix,
	void *container, EB_Hook_Code code, int argc, const unsigned int *argv)
{
	char	buf[FMT_END_CANDIDATE_LEAF_LENGTH + 64];

	if (g_fmt_end_candidate_leaf[0] != '\0') {
		snprintf(buf, sizeof(buf), g_fmt_end_candidate_leaf);
		eb_write_text_string(book, buf);
	}

	return EB_SUCCESS;
}

EB_Error_Code	hook_end_candidate_group(EB_Book *book, EB_Appendix *appendix,
	void *container, EB_Hook_Code code, int argc, const unsigned int *argv)
{
	char	buf[FMT_END_CANDIDATE_GROUP_LENGTH + 64];

	if (g_fmt_end_candidate_group[0] != '\0') {
		snprintf(buf, sizeof(buf), g_fmt_end_candidate_group, argv[1], argv[2]);
		eb_write_text_string(book, buf);
	}

	return EB_SUCCESS;
}

/*
 *.. Ĵ
 */
EB_Error_Code	hook_begin_emphasis(EB_Book *book, EB_Appendix *appendix,
	void *container, EB_Hook_Code code, int argc, const unsigned int *argv)
{
	char	buf[FMT_BEGIN_EMPHASIS_LENGTH + 64];

	if (g_fmt_begin_emphasis[0] != '\0') {
		snprintf(buf, sizeof(buf), g_fmt_begin_emphasis);
		eb_write_text_string(book, buf);
	}

	return EB_SUCCESS;
}

EB_Error_Code	hook_end_emphasis(EB_Book *book, EB_Appendix *appendix,
	void *container, EB_Hook_Code code, int argc, const unsigned int *argv)
{
	char	buf[FMT_END_EMPHASIS_LENGTH + 64];

	if (g_fmt_end_emphasis[0] != '\0') {
		snprintf(buf, sizeof(buf), g_fmt_end_emphasis);
		eb_write_text_string(book, buf);
	}

	return EB_SUCCESS;
}

/*
 *.. 
 */
EB_Error_Code	hook_begin_keyword(EB_Book *book, EB_Appendix *appendix,
	void *container, EB_Hook_Code code, int argc, const unsigned int *argv)
{
	char	buf[FMT_BEGIN_KEYWORD_LENGTH + 64];

	if (g_fmt_begin_keyword[0] != '\0') {
		snprintf(buf, sizeof(buf), g_fmt_begin_keyword);
		eb_write_text_string(book, buf);
	}

	return EB_SUCCESS;
}

EB_Error_Code	hook_end_keyword(EB_Book *book, EB_Appendix *appendix,
	void *container, EB_Hook_Code code, int argc, const unsigned int *argv)
{
	char	buf[FMT_END_KEYWORD_LENGTH + 64];

	if (g_fmt_end_keyword[0] != '\0') {
		snprintf(buf, sizeof(buf), g_fmt_end_keyword);
		eb_write_text_string(book, buf);
	}

	return EB_SUCCESS;
}

/*
 *.. 
 */
EB_Error_Code	hook_begin_decoration(EB_Book *book, EB_Appendix *appendix,
	void *container, EB_Hook_Code code, int argc, const unsigned int *argv)
{
	char	buf[FMT_BEGIN_DECORATION_LENGTH + 64];

	if (g_fmt_begin_decoration[0] != '\0') {
		snprintf(buf, sizeof(buf), g_fmt_begin_decoration);
		eb_write_text_string(book, buf);
	}

	return EB_SUCCESS;
}

EB_Error_Code	hook_end_decoration(EB_Book *book, EB_Appendix *appendix,
	void *container, EB_Hook_Code code, int argc, const unsigned int *argv)
{
	char	buf[FMT_END_DECORATION_LENGTH + 64];

	if (g_fmt_end_decoration[0] != '\0') {
		snprintf(buf, sizeof(buf), g_fmt_end_decoration);
		eb_write_text_string(book, buf);
	}

	return EB_SUCCESS;
}

/*
 *.. 
 */
EB_Error_Code	hook_newline(EB_Book *book, EB_Appendix *appendix,
	void *container, EB_Hook_Code code, int argc, const unsigned int *argv)
{
	char	buf[FMT_NEWLINE_LENGTH + 64];

	if (g_fmt_newline[0] != '\0') {
		snprintf(buf, sizeof(buf), g_fmt_newline);
		eb_write_text_string(book, buf);
	}

	return EB_SUCCESS;
}

/*
 *.. ѳ
 */
EB_Error_Code	hook_gaiji_full(EB_Book *book, EB_Appendix *appendix, void *container,
	EB_Hook_Code code, int argc, const unsigned int *argv)
{
	int		in_code1, in_code2;
	char	*p;
	char	buf1[MAX_GAIJI_LENGTH + 64];
	char	buf2[FMT_GAIJI_FULL_DEFAULT_LENGTH + 64];

	in_code1 = argv[0] >> 8;
	in_code2 = argv[0] & 0xff;
	p = GAIJI_FULL_PTR(in_code1, in_code2);

	if (*p == '\x1b' && *(p+1) == '\0')
		return EB_SUCCESS;

	if (*p != '\0') {
		snprintf(buf1, sizeof(buf1), p);
		eb_write_text_string(book, buf1);
	}
	else {
		snprintf(buf2, sizeof(buf2), g_fmt_gaiji_full_default, argv[0]);
		eb_write_text_string(book, buf2);
	}

	return EB_SUCCESS;
}

/*
 *.. Ⱦѳ
 */
EB_Error_Code	hook_gaiji_half(EB_Book *book, EB_Appendix *appendix, void *container,
	EB_Hook_Code code, int argc, const unsigned int *argv)
{
	int		in_code1, in_code2;
	char	*p;
	char	buf1[MAX_GAIJI_LENGTH + 64];
	char	buf2[FMT_GAIJI_FULL_DEFAULT_LENGTH + 64];

	in_code1 = argv[0] >> 8;
	in_code2 = argv[0] & 0xff;
	p = GAIJI_HALF_PTR(in_code1, in_code2);

	if (*p == '\x1b' && *(p+1) == '\0')
		return EB_SUCCESS;

	if (*p != '\0') {
		snprintf(buf1, sizeof(buf1), p);
		eb_write_text_string(book, buf1);
	}
	else {
		snprintf(buf2, sizeof(buf2), g_fmt_gaiji_half_default, argv[0]);
		eb_write_text_string(book, buf2);
	}

	return EB_SUCCESS;
}

/*
 *.. eb_set_hooks()ѥեåؿꥹ
 */
static const EB_Hook	g_hook_functions[] = {
	{ EB_HOOK_WIDE_JISX0208,        hook_euc_to_output_encoding },
	{ EB_HOOK_NARROW_JISX0208,      hook_euc_to_ascii },
	{ EB_HOOK_SET_INDENT,           hook_set_indent },
	{ EB_HOOK_BEGIN_REFERENCE,      hook_begin_reference },
	{ EB_HOOK_END_REFERENCE,        hook_end_reference },
	{ EB_HOOK_BEGIN_SUBSCRIPT,      hook_begin_subscript },
	{ EB_HOOK_END_SUBSCRIPT,        hook_end_subscript },
	{ EB_HOOK_BEGIN_SUPERSCRIPT,    hook_begin_superscript },
	{ EB_HOOK_END_SUPERSCRIPT,      hook_end_superscript },
	{ EB_HOOK_BEGIN_CANDIDATE,      hook_begin_candidate },
	{ EB_HOOK_END_CANDIDATE_LEAF,   hook_end_candidate_leaf },
	{ EB_HOOK_END_CANDIDATE_GROUP,  hook_end_candidate_group },
	{ EB_HOOK_BEGIN_EMPHASIS,       hook_begin_emphasis },
	{ EB_HOOK_END_EMPHASIS,         hook_end_emphasis },
	{ EB_HOOK_BEGIN_KEYWORD,        hook_begin_keyword },
	{ EB_HOOK_END_KEYWORD,          hook_end_keyword },
	{ EB_HOOK_BEGIN_DECORATION,     hook_begin_decoration },
	{ EB_HOOK_END_DECORATION,       hook_end_decoration },
	{ EB_HOOK_NEWLINE,              hook_newline },
	{ EB_HOOK_WIDE_FONT,            hook_gaiji_full },
	{ EB_HOOK_NARROW_FONT,          hook_gaiji_half },
	{ EB_HOOK_NULL,                 NULL }
};


/*
 *
 *. 
 *
 */

/*
 *.. ϥե
 */
void	set_output_file(char *value, char *source)
{
	FILE	*fp;
	char	*mode;

	if (g_output_file != stdout) {
		fprintf(g_output_file, "Warning: Output file already set. [%s]\n", source);
	}
	else {
		mode = "w";
		if (*value == '+') {
			mode = "a";
			++value;
		}
		if ((fp = fopen(value, mode)) != NULL) {
			g_output_file = fp;
			strncpy(g_output_file_path, value, sizeof(g_output_file_path) - 1);
			g_output_file_path[sizeof(g_output_file_path) - 1] = '\0';
		}
		else {
			fprintf(g_output_file, "Warning: Can't open file. [%s]\n", source);
		}
	}
}

/*
 *.. ҤΥѥ
 */
void	set_book_path(char *value, char *source)
{
	if (strlen(value) < MAX_PATH_SIZE)
		strcpy(g_book_path, value);
	else
		fprintf(g_output_file, "Warning: Too long path. [%s]\n", source);
}

/*
 *.. ֹ
 */
void	set_subbook_number(char *value, char *source)
{
	int		temp;
	char	*endp;

	temp = strtol(value, &endp, 10);
	if (*endp == '\0' && temp >= 1)
		g_subbook_number = temp;
	else
		fprintf(g_output_file, "Warning: Bad syntax. [%s]\n", source);
}

/*
 *.. 󥳡ǥ󥰤
 */
void	set_encoding(char *value, BOOL set_to_input, char *source)
{
	int		i, enc;
	char	*p;

	enc = ENC_INVALID;
	if (strlen(value) == 1) {
		p = strchr(g_encoding_short, *value);
		if (p != NULL)
			enc = p - g_encoding_short;
	}
	else {
		for (i = 0; g_encoding_table[i] != NULL; ++i) {
			if (strcmp(value, g_encoding_table[i]) == 0) {
				enc = i;
				break;
			}
		}
	}

	if (enc != ENC_INVALID) {
		if (set_to_input)
			g_input_encoding = enc;
		else
			g_output_encoding = enc;
	}
	else {
		fprintf(g_output_file, "Warning: Bad syntax. [%s]\n", source);
	}
}

/*
 *.. ᥽åɤ
 */
void	set_search_method(char *value, char *source)
{
	int		i, method;
	char	*p, *top, *next;

	if (*value == '+' || *value == '-') {
		g_enable_fmt_method_start = (*value == '+' ? TRUE : FALSE);
		++value;
	}

	char	value_buffer[strlen(value) + 1];
	strcpy(value_buffer, value);
	top = value_buffer;

	g_search_method_count = 0;

	while (top != NULL) {
		next = NULL;
		if ((p = strchr(top, ',')) != NULL) {
			*p = '\0';
			next = p + 1;
		}

		method = METHOD_INVALID;
		if (strlen(top) == 1) {
			p = strchr(g_method_short, *top);
			if (p != NULL)
				method = p - g_method_short;
		}
		else {
			for (i = 0; g_method_table[i] != NULL; ++i) {
				if (strcmp(top, g_method_table[i]) == 0) {
					method = i;
					break;
				}
			}
		}

		if (method != METHOD_INVALID) {
			if (g_search_method_count < MAX_METHOD) {
				g_search_method[g_search_method_count] = method;
				++g_search_method_count;
			}
			else {
				fprintf(g_output_file, "Warning: Too many search methods. [%s]\n", source);
				break;
			}
		}
		else {
			fprintf(g_output_file, "Warning: Bad syntax. [%s]\n", source);
			break;
		}

		top = next;
	}
}

/*
 *.. ʸɽ
 */
void	set_text_view(char *value, char *source)
{
	int		temp;
	char	*endp;

	if (*value == '+' && *(value+1) == '\0') {
		g_text_view = TEXT_VIEW_NORMAL;
	}
	else if (*value == '-' && *(value+1) == '\0') {
		g_text_view = 0;
	}
	else if (strcmp(value, "max") == 0) {
		g_text_view = MAX_HIT_ENTRIES;
	}
	else {
		temp = strtol(value, &endp, 10);
		if (*endp == '\0' && temp >= 0) {
			if (temp <= MAX_HIT_ENTRIES)
				g_text_view = temp;
			else
				fprintf(g_output_file, "Warning: Too big number. [%s]\n", source);
		}
		else {
			fprintf(g_output_file, "Warning: Bad syntax. [%s]\n", source);
		}
	}
}

/*
 *.. Фɽ
 */
void	set_list_view(char *value, char *source)
{
	int		temp;
	char	*endp;

	if (*value == '-' && *(value+1) == '\0') {
		g_list_view = 0;
	}
	else if (strcmp(value, "max") == 0) {
		g_list_view = MAX_HIT_ENTRIES;
	}
	else {
		temp = strtol(value, &endp, 10);
		if (*endp == '\0' && temp >= 0) {
			if (temp <= MAX_HIT_ENTRIES)
				g_list_view = temp;
			else
				fprintf(g_output_file, "Warning: Too big number. [%s]\n", source);
		}
		else {
			fprintf(g_output_file, "Warning: Bad syntax. [%s]\n", source);
		}
	}
}

/*
 *.. եޥåʸΥԡ
 *   valuedestʸ򥳥ԡ
 *   \ץ󥹤%ѴҤβϤ
 *   ʸХȿbytes-1¿硢%%Τ%οmax_args¿硢
 *   뤤%ѴҤν񼰤ʾϥ顼ȤʤꡢԡϤʤʤ
 */
void	format_copy(char *dest, char *value, int bytes, int max_args, char *source)
{
	char		buf[bytes];
	char		*p1, *p2;
	int			args;
	unsigned	u;
	char		*errmsg;

	p1 = buf;
	p2 = value;
	args = 0;
	while (*p2) {
		if (*p2 == '%') {
			*p1++ = *p2++;
			--bytes;
			if (bytes < 1) {
				errmsg = "Warning: String too long. [%s]\n";
				goto error_return;
			}
			if (*p2 == '%') {
				*p1++ = *p2++;
				--bytes;
				if (bytes < 1) {
					errmsg = "Warning: String too long. [%s]\n";
					goto error_return;
				}
			}
			else {
				++args;
				if (args > max_args) {
					errmsg = "Warning: '%%' too many. [%s]\n";
					goto error_return;
				}
				while (isdigit(*p2)) {
					*p1++ = *p2++;
					--bytes;
					if (bytes < 1) {
						errmsg = "Warning: String too long. [%s]\n";
						goto error_return;
					}
				}
				if (*p2 == 'd' || *p2 == 'u' || *p2 == 'x' || *p2 == 'X') {
					*p1++ = *p2++;
					--bytes;
					if (bytes < 1) {
						errmsg = "Warning: String too long. [%s]\n";
						goto error_return;
					}
				}
				else {
					errmsg = "Warning: Invalid '%%' sequence. [%s]\n";
					goto error_return;
				}
			}
		}
		else if (*p2 == '\\') {
			++p2;
			switch (*p2) {
				case 't':
					*p1++ = '\t';
					++p2;
					--bytes;
					break;
				case 'n':
					*p1++ = '\n';
					++p2;
					--bytes;
					break;
				case 'e':
					*p1++ = '\x1b';
					++p2;
					--bytes;
					break;
				case 's':
					*p1++ = ' ';
					++p2;
					--bytes;
					break;
				case 'x':
					++p2;
					if (isxdigit(*p2)) {
						u = (isdigit(*p2) ? *p2 - '0' : 10 + toupper(*p2) - 'A');
						++p2;
						if (isxdigit(*p2)) {
							u *= 16;
							u += (isdigit(*p2) ? *p2 - '0' : 10 + toupper(*p2) - 'A');
							++p2;
						}
						*p1++ = u;
						--bytes;
					}
					break;
				case '\\':
					*p1++ = '\\';
					++p2;
					--bytes;
					break;
				default:
					break;
			}
			if (bytes < 1) {
				errmsg = "Warning: String too long. [%s]\n";
				goto error_return;
			}
		}
		else {
			*p1++ = *p2++;
			--bytes;
			if (bytes < 1) {
				errmsg = "Warning: String too long. [%s]\n";
				goto error_return;
			}
		}
	}
	*p1 = '\0';

	strcpy(dest, buf);
	return;

error_return:
	fprintf(g_output_file, errmsg, source);
	return;
}

/*
 *.. եβ
 */
void	parse_config_file(char *config_file, char *source)
{
	FILE		*fp;
	char		para[MAX_PARA_SIZE];
	char		*key, *value;
	unsigned 	gaiji_code;
	int			in_code1, in_code2;
	char		*p, *endp;
	BOOL		gaiji_error_occurred;

	if ((fp = fopen(config_file, "r")) == NULL) {
		fprintf(g_output_file, "Warning: Can't open file. [%s]\n", source);
		return;
	}

	while (get_para(para, sizeof(para), fp) != NULL) {
		if ((p = strchr(para, ';')) != NULL)
			*p = '\0';
		if ((p = strchr(para, '=')) != NULL) {
			*p = '\0';
			key = get_word_top(para);
			remove_trailing_space(key);
			value = get_word_top(p + 1);
			remove_trailing_space(value);

			p = key;
			if (*p == '@') {
				++p;
				gaiji_error_occurred = TRUE;
				if (*p == 'f' || *p == 'h') {
					gaiji_code = strtol(p + 1, &endp, 16);
					in_code1 = (gaiji_code & 0xff00) >> 8;
					in_code2 = gaiji_code & 0xff;
					if (*endp == '\0' &&
						gaiji_code <= 0xffff &&
						0xa1 <= in_code1 && in_code1 <= 0xfe &&
						0x21 <= in_code2 && in_code2 <= 0x7e)
					{
						if (*p == 'f')
							format_copy(GAIJI_FULL_PTR(in_code1, in_code2), value, MAX_GAIJI_LENGTH, MAX_GAIJI_ARGS, key);
						else
							format_copy(GAIJI_HALF_PTR(in_code1, in_code2), value, MAX_GAIJI_LENGTH, MAX_GAIJI_ARGS, key);
						gaiji_error_occurred = FALSE;
					}
				}
				if (gaiji_error_occurred)
					fprintf(g_output_file, "Warning: Bad syntax. [%s]\n", key);
			}
			else if (*p == '%') {
				++p;
 				if (strncmp(p, "Indent", 6) == 0 && '0' <= p[6] && p[6] <= '7' && p[7] == '\0')
					format_copy(FMT_INDENT_PTR(p[6] - '0'), value, FMT_INDENT_LENGTH, FMT_INDENT_ARGS, key);
 				else if (strcmp(p, "BeginReference") == 0)
					format_copy(g_fmt_begin_reference, value, FMT_BEGIN_REFERENCE_LENGTH, FMT_BEGIN_REFERENCE_ARGS, key);
				else if (strcmp(p, "EndReference") == 0)
					format_copy(g_fmt_end_reference, value, FMT_END_REFERENCE_LENGTH, FMT_END_REFERENCE_ARGS, key);
 				else if (strcmp(p, "BeginSubscript") == 0)
					format_copy(g_fmt_begin_subscript, value, FMT_BEGIN_SUBSCRIPT_LENGTH, FMT_BEGIN_SUBSCRIPT_ARGS, key);
				else if (strcmp(p, "EndSubscript") == 0)
					format_copy(g_fmt_end_subscript, value, FMT_END_SUBSCRIPT_LENGTH, FMT_END_SUBSCRIPT_ARGS, key);
 				else if (strcmp(p, "BeginSuperscript") == 0)
					format_copy(g_fmt_begin_superscript, value, FMT_BEGIN_SUPERSCRIPT_LENGTH, FMT_BEGIN_SUPERSCRIPT_ARGS, key);
				else if (strcmp(p, "EndSuperscript") == 0)
					format_copy(g_fmt_end_superscript, value, FMT_END_SUPERSCRIPT_LENGTH, FMT_END_SUPERSCRIPT_ARGS, key);
				else if (strcmp(p, "BeginCandidate") == 0)
					format_copy(g_fmt_begin_candidate, value, FMT_BEGIN_CANDIDATE_LENGTH, FMT_BEGIN_CANDIDATE_ARGS, key);
				else if (strcmp(p, "EndCandidateLeaf") == 0)
					format_copy(g_fmt_end_candidate_leaf, value, FMT_END_CANDIDATE_LEAF_LENGTH, FMT_END_CANDIDATE_LEAF_ARGS, key);
				else if (strcmp(p, "EndCandidateGroup") == 0)
					format_copy(g_fmt_end_candidate_group, value, FMT_END_CANDIDATE_GROUP_LENGTH, FMT_END_CANDIDATE_GROUP_ARGS, key);
 				else if (strcmp(p, "BeginEmphasis") == 0)
					format_copy(g_fmt_begin_emphasis, value, FMT_BEGIN_EMPHASIS_LENGTH, FMT_BEGIN_EMPHASIS_ARGS, key);
				else if (strcmp(p, "EndEmphasis") == 0)
					format_copy(g_fmt_end_emphasis, value, FMT_END_EMPHASIS_LENGTH, FMT_END_EMPHASIS_ARGS, key);
 				else if (strcmp(p, "BeginKeyword") == 0)
					format_copy(g_fmt_begin_keyword, value, FMT_BEGIN_KEYWORD_LENGTH, FMT_BEGIN_KEYWORD_ARGS, key);
				else if (strcmp(p, "EndKeyword") == 0)
					format_copy(g_fmt_end_keyword, value, FMT_END_KEYWORD_LENGTH, FMT_END_KEYWORD_ARGS, key);
 				else if (strcmp(p, "BeginDecoration") == 0)
					format_copy(g_fmt_begin_decoration, value, FMT_BEGIN_DECORATION_LENGTH, FMT_BEGIN_DECORATION_ARGS, key);
				else if (strcmp(p, "EndDecoration") == 0)
					format_copy(g_fmt_end_decoration, value, FMT_END_DECORATION_LENGTH, FMT_END_DECORATION_ARGS, key);
 				else if (strcmp(p, "Newline") == 0)
					format_copy(g_fmt_newline, value, FMT_NEWLINE_LENGTH, FMT_NEWLINE_ARGS, key);
 				else if (strcmp(p, "GaijiFullDefault") == 0)
					format_copy(g_fmt_gaiji_full_default, value, FMT_GAIJI_FULL_DEFAULT_LENGTH, FMT_GAIJI_FULL_DEFAULT_ARGS, key);
 				else if (strcmp(p, "GaijiHalfDefault") == 0)
					format_copy(g_fmt_gaiji_half_default, value, FMT_GAIJI_HALF_DEFAULT_LENGTH, FMT_GAIJI_HALF_DEFAULT_ARGS, key);
				else
					fprintf(g_output_file, "Warning: Unknown key. [%s]\n", key);
			}
			else if (*p == '$') {
				++p;
				if (strcmp(p, "BookStart") == 0)
					format_copy(g_fmt_book_start, value, FMT_BOOK_START_LENGTH, FMT_BOOK_START_ARGS, key);
				else if (strcmp(p, "MethodWordStart") == 0)
					format_copy(FMT_METHOD_START_PTR(METHOD_WORD), value, FMT_METHOD_START_LENGTH, FMT_METHOD_START_ARGS, key);
				else if (strcmp(p, "MethodEndwordStart") == 0)
					format_copy(FMT_METHOD_START_PTR(METHOD_ENDWORD), value, FMT_METHOD_START_LENGTH, FMT_METHOD_START_ARGS, key);
				else if (strcmp(p, "MethodKeywordStart") == 0)
					format_copy(FMT_METHOD_START_PTR(METHOD_KEYWORD), value, FMT_METHOD_START_LENGTH, FMT_METHOD_START_ARGS, key);
				else if (strcmp(p, "MethodCrossStart") == 0)
					format_copy(FMT_METHOD_START_PTR(METHOD_CROSS), value, FMT_METHOD_START_LENGTH, FMT_METHOD_START_ARGS, key);
				else if (strcmp(p, "MethodLinkStart") == 0)
					format_copy(FMT_METHOD_START_PTR(METHOD_LINK), value, FMT_METHOD_START_LENGTH, FMT_METHOD_START_ARGS, key);
				else if (strcmp(p, "MethodMenuStart") == 0)
					format_copy(FMT_METHOD_START_PTR(METHOD_MENU), value, FMT_METHOD_START_LENGTH, FMT_METHOD_START_ARGS, key);
				else if (strcmp(p, "MethodCopyrightStart") == 0)
					format_copy(FMT_METHOD_START_PTR(METHOD_COPYRIGHT), value, FMT_METHOD_START_LENGTH, FMT_METHOD_START_ARGS, key);
				else if (strcmp(p, "TextItemStart") == 0)
					format_copy(g_fmt_text_item_start, value, FMT_TEXT_ITEM_START_LENGTH, FMT_TEXT_ITEM_START_ARGS, key);
				else if (strcmp(p, "TextItemEnd") == 0)
					format_copy(g_fmt_text_item_end, value, FMT_TEXT_ITEM_END_LENGTH, FMT_TEXT_ITEM_END_ARGS, key);
				else if (strcmp(p, "ListStart") == 0)
					format_copy(g_fmt_list_start, value, FMT_LIST_START_LENGTH, FMT_LIST_START_ARGS, key);
				else if (strcmp(p, "ListItemStart") == 0)
					format_copy(g_fmt_list_item_start, value, FMT_LIST_ITEM_START_LENGTH, FMT_LIST_ITEM_START_ARGS, key);
				else if (strcmp(p, "ListItemEnd") == 0)
					format_copy(g_fmt_list_item_end, value, FMT_LIST_ITEM_END_LENGTH, FMT_LIST_ITEM_END_ARGS, key);
				else if (strcmp(p, "ListEnd") == 0)
					format_copy(g_fmt_list_end, value, FMT_LIST_END_LENGTH, FMT_LIST_END_ARGS, key);
				else if (strcmp(p, "BookEnd") == 0)
					format_copy(g_fmt_book_end, value, FMT_BOOK_END_LENGTH, FMT_BOOK_END_ARGS, key);
				else
					fprintf(g_output_file, "Warning: Unknown key. [%s]\n", key);
			}
			else {
				if (strcmp(p, "BookPath") == 0)
					set_book_path(value, key);
				else if (strcmp(p, "SubBookNumber") == 0)
					set_subbook_number(value, key);
				else if (strcmp(p, "OutputEncoding") == 0)
					set_encoding(value, SET_ENC_OUTPUT, key);
				else if (strcmp(p, "TextView") == 0)
					set_text_view(value, key);
				else if (strcmp(p, "ListView") == 0)
					set_list_view(value, key);
				else
					fprintf(g_output_file, "Warning: Unknown key. [%s]\n", key);
			}
		}
	}

	fclose(fp);
}

/*
 *.. ޥɥ饤󥪥ץβ
 */
void	parse_option(int argc, char *argv[])
{
	int		i;
	char	*p;

	for (i = 1; i < argc; ++i) {
		p = argv[i];
		if (*p++ == '-') {
			switch (*p++) {
				case 'o':
					set_output_file(p, argv[i]);
					break;
				case 'c':
					parse_config_file(p, argv[i]);
					break;
				case 'b':
					set_book_path(p, argv[i]);
					break;
				case 'n':
					set_subbook_number(p, argv[i]);
					break;
				case 'K':
					if (*p == 'I')
						set_encoding(p + 1, SET_ENC_INPUT, argv[i]);
					else if (*p == 'O')
						set_encoding(p + 1, SET_ENC_OUTPUT, argv[i]);
					else
						fprintf(g_output_file, "Warning: Bad syntax. [%s]\n", argv[i]);
					break;
				case 'm':
					set_search_method(p, argv[i]);
					break;
				case 't':
					set_text_view(p, argv[i]);
					break;
				case 'l':
					set_list_view(p, argv[i]);
					break;
				case 's':
					if (*p != '\0') {
						if (g_search_word_count < MAX_SEARCH_WORD) {
							g_search_word_ptr[g_search_word_count] = p;
							++g_search_word_count;
							g_search_word_ptr[g_search_word_count] = NULL;
							g_search_word_buffer_size += (strlen(p) * 2 + 1);
							/* 󥳡ǥѴθ'\0'礭û */
						}
						else {
							fprintf(g_output_file, "Warning: Too many search words. [%s]\n", argv[i]);
						}
					}
					else {
						fprintf(g_output_file, "Warning: Bad syntax. [%s]\n", argv[i]);
					}
					break;
				case 'x':
					switch (*p++) {
						case '0':
							if (*p == '+')			g_enable_config_display = TRUE;
							else if (*p == '-')		g_enable_config_display = FALSE;
							break;
						case '1':
							if (*p == '+')			g_enable_utf8_ex_conv = TRUE;
							else if (*p == '-')		g_enable_utf8_ex_conv = FALSE;
							break;
					}
					break;
				default:
					fprintf(g_output_file, "Warning: Unknown option. [%s]\n", argv[i]);
					break;
			}
		}
		else {
			fprintf(g_output_file, "Warning: Unknown option. [%s]\n", argv[i]);
		}
	}
}

/*
 *.. Ķѿβ
 */
void	parse_env(void)
{
	char	*p;

	if ((p = getenv("EBMINI_OUTFILE")) != NULL)
		set_output_file(p, "EBMINI_OUTFILE");

	if ((p = getenv("EBMINI_CFGFILE")) != NULL)
		parse_config_file(p, "EBMINI_CFGFILE");

	if ((p = getenv("EBMINI_BOOKPATH")) != NULL)
		set_book_path(p, "EBMINI_BOOKPATH");

	if ((p = getenv("EBMINI_SUBBOOK")) != NULL)
		set_subbook_number(p, "EBMINI_SUBBOOK");

	if ((p = getenv("EBMINI_INCODE")) != NULL)
		set_encoding(p, SET_ENC_INPUT, "EBMINI_INCODE");

	if ((p = getenv("EBMINI_OUTCODE")) != NULL)
		set_encoding(p, SET_ENC_OUTPUT, "EBMINI_OUTCODE");

	if ((p = getenv("EBMINI_METHOD")) != NULL)
		set_search_method(p, "EBMINI_METHOD");

	if ((p = getenv("EBMINI_TEXTVIEW")) != NULL)
		set_text_view(p, "EBMINI_TEXTVIEW");

	if ((p = getenv("EBMINI_LISTVIEW")) != NULL)
		set_list_view(p, "EBMINI_LISTVIEW");
}

/*
 *.. Хѿν
 */
void	global_init(void)
{
	int		i, n;
	char	*p;

	g_output_file = stdout;
	g_book_path[0] = '\0';

	/* եޥåʸ */
	g_fmt_book_start[0] = '\0';
	p = g_fmt_method_start;
	for (i = 0; i < MAX_METHOD; ++i) {
		*p = '\0';
		p += FMT_METHOD_START_LENGTH;
	}
	g_fmt_text_item_start[0] = '\0';
	strcpy(g_fmt_text_item_end, "\n");
	strcpy(g_fmt_list_start, "<Heading-List>\n");
	g_fmt_list_item_start[0] = '\0';
	strcpy(g_fmt_list_item_end, "\n");
	strcpy(g_fmt_list_end, "\n");
	strcpy(g_fmt_book_end, "\n");

	p = g_fmt_indent;
	for (i = 0; i < MAX_FMT_INDENT; ++i) {
		*p = '\0';
		p += FMT_INDENT_LENGTH;
	}
	strcpy(g_fmt_begin_reference, "<");
	strcpy(g_fmt_end_reference, "|%d:%d>");
	g_fmt_begin_subscript[0] = '\0';
	g_fmt_end_subscript[0] = '\0';
	g_fmt_begin_superscript[0] = '\0';
	g_fmt_end_superscript[0] = '\0';
	g_fmt_begin_candidate[0] = '\0';
	g_fmt_end_candidate_leaf[0] = '\0';
	g_fmt_end_candidate_group[0] = '\0';
	g_fmt_begin_emphasis[0] = '\0';
	g_fmt_end_emphasis[0] = '\0';
	g_fmt_begin_keyword[0] = '\0';
	g_fmt_end_keyword[0] = '\0';
	g_fmt_begin_decoration[0] = '\0';
	g_fmt_end_decoration[0] = '\0';
	strcpy(g_fmt_newline, "\n");
	strcpy(g_fmt_gaiji_full_default, "[@f%04X]");
	strcpy(g_fmt_gaiji_half_default, "[@h%04X]");

	/*  */
	p = g_gaiji_full_buffer;
	for (n = 1; n <= MAX_GAIJI_NUMBER; ++n) {
		*p = '\0';
		p += MAX_GAIJI_LENGTH;
	}
	p = g_gaiji_half_buffer;
	for (n = 1; n <= MAX_GAIJI_NUMBER; ++n) {
		*p = '\0';
		p += MAX_GAIJI_LENGTH;
	}
}


/*
 *
 *. ᥤץ
 *
 */

/*
 *.. ҳʸν
 */
void	fmtout_book_start(void)
{
	char	buf[FMT_BOOK_START_LENGTH + 64];

	if (g_fmt_book_start[0] != '\0') {
		snprintf(buf, sizeof(buf), g_fmt_book_start);
		fputs(buf, g_output_file);
	}
}

/*
 *.. ᥽åɳʸν
 */
void	fmtout_method_start(int method)
{
	char	buf[FMT_METHOD_START_LENGTH + 64];
	char	*p = FMT_METHOD_START_PTR(method);

	if (*p != '\0') {
		snprintf(buf, sizeof(buf), p);
		fputs(buf, g_output_file);
	}
}

/*
 *.. ʸʸν
 */
void	fmtout_text_item_start(void)
{
	char	buf[FMT_TEXT_ITEM_START_LENGTH + 64];

	if (g_fmt_text_item_start[0] != '\0') {
		snprintf(buf, sizeof(buf), g_fmt_text_item_start);
		fputs(buf, g_output_file);
	}
}

/*
 *.. ʸλʸν
 */
void	fmtout_text_item_end(void)
{
	char	buf[FMT_TEXT_ITEM_END_LENGTH + 64];

	if (g_fmt_text_item_end[0] != '\0') {
		snprintf(buf, sizeof(buf), g_fmt_text_item_end);
		fputs(buf, g_output_file);
	}
}

/*
 *.. Фʸν
 */
void	fmtout_list_start(void)
{
	char	buf[FMT_LIST_START_LENGTH + 64];

	if (g_fmt_list_start[0] != '\0') {
		snprintf(buf, sizeof(buf), g_fmt_list_start);
		fputs(buf, g_output_file);
	}
}

/*
 *.. Фܤγʸν
 */
void	fmtout_list_item_start(int page, int offset)
{
	char	buf[FMT_LIST_ITEM_START_LENGTH + 64];

	if (g_fmt_list_item_start[0] != '\0') {
		snprintf(buf, sizeof(buf), g_fmt_list_item_start, page, offset);
		fputs(buf, g_output_file);
	}
}

/*
 *.. Фܤνλʸν
 */
void	fmtout_list_item_end(int page, int offset)
{
	char	buf[FMT_LIST_ITEM_END_LENGTH + 64];

	if (g_fmt_list_item_end[0] != '\0') {
		snprintf(buf, sizeof(buf), g_fmt_list_item_end, page, offset);
		fputs(buf, g_output_file);
	}
}

/*
 *.. Фλʸν
 */
void	fmtout_list_end(void)
{
	char	buf[FMT_LIST_END_LENGTH + 64];

	if (g_fmt_list_end[0] != '\0') {
		snprintf(buf, sizeof(buf), g_fmt_list_end);
		fputs(buf, g_output_file);
	}
}

/*
 *.. ҽλʸν
 */
void	fmtout_book_end(void)
{
	char	buf[FMT_BOOK_END_LENGTH + 64];

	if (g_fmt_book_end[0] != '\0') {
		snprintf(buf, sizeof(buf), g_fmt_book_end);
		fputs(buf, g_output_file);
	}
}

/*
 *.. ꤷ֤νҥǡν - ɸ
 */
void	data_output(EB_Position *position, BOOL data_is_text)
{
	char			data_buffer[MAX_BUFFER_SIZE];
	ssize_t			data_length;

	if (eb_seek_text(&g_book_object, position) == EB_SUCCESS) {
		if (data_is_text) {
			for (;;) {
				if (eb_read_text(&g_book_object, NULL, &g_hookset_object, NULL,
					MAX_BUFFER_SIZE - 1, data_buffer, &data_length) != EB_SUCCESS)
				{
					fprintf(g_output_file, "eb_read_text() failed.\n");
					break;
				}
				if (data_length == 0)
					break;
				fputs(data_buffer, g_output_file);
			}
		}
		else {
			for (;;) {
				if (eb_read_heading(&g_book_object, NULL, &g_hookset_object, NULL,
					MAX_BUFFER_SIZE - 1, data_buffer, &data_length) != EB_SUCCESS)
				{
					fprintf(g_output_file, "eb_read_heading() failed.\n");
					break;
				}
				if (data_length == 0)
					break;
				fputs(data_buffer, g_output_file);
			}
		}
	}
	else {
		fprintf(g_output_file, "eb_seek_text() failed.\n");
	}
}

/*
 *.. ꤷ֤νҥǡν - 
 */
void	data_output_cross(EB_Position *position, BOOL heading_and_text)
{
	char			data_buffer[MAX_BUFFER_SIZE];
	ssize_t			data_length;

	if (eb_seek_text(&g_book_object, position) == EB_SUCCESS) {
		for (;;) {
			if (eb_read_heading(&g_book_object, NULL, &g_hookset_object, NULL,
				MAX_BUFFER_SIZE - 1, data_buffer, &data_length) != EB_SUCCESS)
			{
				fprintf(g_output_file, "eb_read_heading() failed.\n");
				break;
			}
			if (data_length == 0)
				break;
			fputs(data_buffer, g_output_file);
		}

		if (heading_and_text) {
			fprintf(g_output_file, "\n");
			if (eb_forward_heading(&g_book_object) != EB_SUCCESS) {
				fprintf(g_output_file, "eb_forward_heading() failed.\n");
			}
			else {
				for (;;) {
					if (eb_read_heading(&g_book_object, NULL, &g_hookset_object, NULL,
						MAX_BUFFER_SIZE - 1, data_buffer, &data_length) != EB_SUCCESS)
					{
						fprintf(g_output_file, "eb_read_heading() failed.\n");
						break;
					}
					if (data_length == 0)
						break;
					fputs(data_buffer, g_output_file);
				}
				fprintf(g_output_file, "\n");
			}
		}
	}
	else {
		fprintf(g_output_file, "eb_seek_text() failed.\n");
	}
}

/*
 *.. ʣȥȽ
 */
BOOL	is_redundant_entry(EB_Hit *hit_item, EB_Hit hit_entries[], int entries_count)
{
	BOOL		result;
	char		data_buffer1[MAX_BUFFER_SIZE];
	char		data_buffer2[MAX_BUFFER_SIZE];
	ssize_t		data_length1;
	ssize_t		data_length2;
	int			i;

	result = FALSE;
	for (i = entries_count - 1; i >= 0; --i) {
		/* ʸΰ֤ */
		if (hit_item->text.page != hit_entries[i].text.page ||
			hit_item->text.offset != hit_entries[i].text.offset) 
			continue;

		/* ʸΰ֤Ʊ硢ޤФΰ֤ */
		if (hit_item->heading.page == hit_entries[i].heading.page &&
			hit_item->heading.offset == hit_entries[i].heading.offset)
		{
			result = TRUE;
			break;
		}

		/* Фΰ֤ۤʤϡ˸Фʸ */
		data_buffer1[0] = '\0';
		data_buffer2[0] = '\0';
		if (eb_seek_text(&g_book_object, &hit_item->heading) != EB_SUCCESS)
			continue;
		if (eb_read_heading(&g_book_object, NULL, &g_hookset_object, NULL,
			MAX_BUFFER_SIZE - 1, data_buffer1, &data_length1) != EB_SUCCESS)
			continue;
		if (eb_seek_text(&g_book_object, &hit_entries[i].heading) != EB_SUCCESS)
			continue;
		if (eb_read_heading(&g_book_object, NULL, &g_hookset_object, NULL,
			MAX_BUFFER_SIZE - 1, data_buffer2, &data_length2) != EB_SUCCESS)
			continue;
		if (strcmp(data_buffer1, data_buffer2) == 0) {
			result = TRUE;
			break;
		}
	}

	return result;
}

/*
 *.. ȥμ
 */
int		get_entries(EB_Hit hit_entries[], int limit)
{
	EB_Hit	hit_item;
	int		hit_count;
	int		entries_count;

	entries_count = 0;
	while (entries_count < limit) {
		if (eb_hit_list(&g_book_object, 1, &hit_item, &hit_count) != EB_SUCCESS)
			break;
		if (hit_count == 0)
			break;
		if (is_redundant_entry(&hit_item, hit_entries, entries_count))
			continue;
		hit_entries[entries_count] = hit_item;
		++entries_count;
	}

	return entries_count;
}

/*
 *.. ס׸
 */
void	search_word_endword(int search_method)
{
	EB_Error_Code	(*search_func)();
	search_func = (search_method == METHOD_WORD ? eb_search_word : eb_search_endword);

	EB_Hit	hit_entries[MAX_HIT_ENTRIES];
	int		entries_count;

	int		i, text_limit;
	char	*p;

	/* Ϣ */
	int		combined_length = 0;
	for (i = 0; g_search_word_ptr[i] != NULL; ++i)
		combined_length += strlen(g_search_word_ptr[i]);

	char	combined_search_word[combined_length + 1];
	p = combined_search_word;
	for (i = 0; g_search_word_ptr[i] != NULL; ++i) {
		strcpy(p, g_search_word_ptr[i]);
		while (*p)
			++p;
	}

	/* ʸ */
	entries_count = 0;
	if (g_text_view == TEXT_VIEW_NORMAL) {
		if (eb_search_exactword(&g_book_object, combined_search_word) == EB_SUCCESS)
			entries_count = get_entries(hit_entries, MAX_HIT_ENTRIES);
		else
			fprintf(g_output_file, "eb_search_exactword() failed.\n\n");
		text_limit = entries_count;
	}
	else {
		text_limit = g_text_view;
	}

	if ((*search_func)(&g_book_object, combined_search_word) == EB_SUCCESS)
			entries_count = get_entries(hit_entries, MAX(text_limit, g_list_view));
	else
		fprintf(g_output_file, "eb_search_%s() failed.\n\n", (search_method == METHOD_WORD ? "word" : "endword"));

	for (i = 0; i < entries_count; ++i) {
		if (i >= text_limit)
			break;
		fmtout_text_item_start();
		data_output(&hit_entries[i].text, DATAOUT_TEXT);
		fmtout_text_item_end();
	}

	/* Ф */
	if (g_list_view != 0) {
		fmtout_list_start();
		for (i = 0; i < entries_count; ++i) {
			if (i >= g_list_view)
				break;
			fmtout_list_item_start(hit_entries[i].text.page, hit_entries[i].text.offset);
			data_output(&hit_entries[i].heading, DATAOUT_HEADING);
			fmtout_list_item_end(hit_entries[i].text.page, hit_entries[i].text.offset);
		}
		fmtout_list_end();
	}
}

/*
 *.. ︡
 */
void	search_keyword_cross(int search_method)
{
	EB_Error_Code	(*search_func)();
	search_func = (search_method == METHOD_KEYWORD ? eb_search_keyword : eb_search_cross);

	EB_Hit	hit_entries[MAX_HIT_ENTRIES];
	int		entries_count;

	int		i, text_limit;

	text_limit = (g_text_view == TEXT_VIEW_NORMAL ? MAX_HIT_ENTRIES : g_text_view);
	entries_count = 0;
	if ((*search_func)(&g_book_object, (const char **)g_search_word_ptr) == EB_SUCCESS)
		entries_count = get_entries(hit_entries, MAX(text_limit, g_list_view));
	else
		fprintf(g_output_file, "eb_search_%s() failed.\n\n", (search_method == METHOD_KEYWORD ? "keyword" : "cross"));

	/* ʸ */
	for (i = 0; i < entries_count; ++i) {
		if (i >= text_limit)
			break;
		fmtout_text_item_start();
		if (search_method == METHOD_KEYWORD)
			data_output(&hit_entries[i].text, DATAOUT_TEXT);
		else
			data_output_cross(&hit_entries[i].text, DATAOUT_CROSS_HEADING_AND_TEXT);
		fmtout_text_item_end();
	}

	/* Ф */
	if (g_list_view != 0) {
		fmtout_list_start();
		for (i = 0; i < entries_count; ++i) {
			if (i >= g_list_view)
				break;
			fmtout_list_item_start(hit_entries[i].text.page, hit_entries[i].text.offset);
			if (search_method == METHOD_KEYWORD)
				data_output(&hit_entries[i].heading, DATAOUT_HEADING);
			else
				data_output_cross(&hit_entries[i].text, DATAOUT_CROSS_HEADING_ONLY);
			fmtout_list_item_end(hit_entries[i].text.page, hit_entries[i].text.offset);
		}
		fmtout_list_end();
	}
}

/*
 *.. 󥯸
 */
void	search_link(void)
{
	EB_Position		search_location;
	int		i, temp;
	char	*p1, *p2, *endp;

	for (i = 0; g_search_word_ptr[i] != NULL; ++i) {
		/* 줫ڡֹȥեåȤ */
		search_location.page = 0;
		search_location.offset = 0;
		p1 = g_search_word_ptr[i];
		if ((p2 = strchr(g_search_word_ptr[i], ':')) != NULL) {
			*p2++ = '\0';
			temp = strtol(p1, &endp, 10);
			if (*endp == '\0')
				search_location.page = temp;
			temp = strtol(p2, &endp, 10);
			if (*endp == '\0')
				search_location.offset = temp;
		}

		/* ʸ */
		if (g_text_view != 0) {
			fmtout_text_item_start();
			data_output(&search_location, DATAOUT_TEXT);
			fmtout_text_item_end();
		}

		/* Ф */
		if (g_list_view != 0) {
			fmtout_list_start();
			fmtout_list_item_start(search_location.page, search_location.offset);
			data_output(&search_location, DATAOUT_HEADING);
			fmtout_list_item_end(search_location.page, search_location.offset);
			fmtout_list_end();
		}
	}
}

/*
 *.. ˥塼
 */
void	search_menu(void)
{
	EB_Position		search_location;

	if (eb_menu(&g_book_object, &search_location) == EB_SUCCESS)
		data_output(&search_location, DATAOUT_TEXT);
	else
		fprintf(g_output_file, "eb_menu() failed.\n");
}

/*
 *.. ɽ
 */
void	search_copyright(void)
{
	EB_Position		search_location;

	if (eb_copyright(&g_book_object, &search_location) == EB_SUCCESS)
		data_output(&search_location, DATAOUT_TEXT);
	else
		fprintf(g_output_file, "eb_copyright() failed.\n");
}

/*
 *.. ᥤ
 */
void	search_main(void)
{
	int		i;

	for (i = 0; i < g_search_method_count; ++i) {
		if (g_enable_fmt_method_start == TRUE)
			fmtout_method_start(g_search_method[i]);
		switch (g_search_method[i]) {
			case METHOD_WORD:
			case METHOD_ENDWORD:
				if (g_search_word_count == 0)
					fprintf(g_output_file, "Search word not given.\n");
				else
					search_word_endword(g_search_method[i]);
				break;
			case METHOD_KEYWORD:
			case METHOD_CROSS:
				if (g_search_word_count == 0)
					fprintf(g_output_file, "Search word not given.\n");
				else
					search_keyword_cross(g_search_method[i]);
				break;
			case METHOD_LINK:
				if (g_search_word_count == 0)
					fprintf(g_output_file, "Search word not given.\n");
				else
					search_link();
				break;
			case METHOD_MENU:
				search_menu();
				break;
			case METHOD_COPYRIGHT:
				search_copyright();
				break;
		}
	}
}

/*
 *.. ˡɽ
 */
void	usage(void)
{
	fprintf(g_output_file, "\n");
	fprintf(g_output_file, "Usage:  ebmini [Options]\n");
	fprintf(g_output_file, "\n");
	fprintf(g_output_file, "  -o[+]<Path>        Output File Path ('+' = append)  [EBMINI_OUTFILE]\n");
	fprintf(g_output_file, "  -c<Path>           Config File Path                 [EBMINI_CFGFILE]\n");
	fprintf(g_output_file, "  -b<Path>           Book Path                        [EBMINI_BOOKPATH]\n");
	fprintf(g_output_file, "  -n<Number>         SubBook Number                   [EBMINI_SUBBOOK]\n");
	fprintf(g_output_file, "  -KI<Encoding>      Input Character Encoding         [EBMINI_INCODE]\n");
	fprintf(g_output_file, "  -KO<Encoding>      Output Character Encoding        [EBMINI_OUTCODE]\n");
	fprintf(g_output_file, "  -m<Method>         Search Method                    [EBMINI_METHOD]\n");
	fprintf(g_output_file, "  -t<Setting>        Text View Setting                [EBMINI_TEXTVIEW]\n");
	fprintf(g_output_file, "  -l<Setting>        List View Setting                [EBMINI_LISTVIEW]\n");
	fprintf(g_output_file, "  -s<Word>           Search Word\n");
	fprintf(g_output_file, "  -s<Page>:<Offset>  Search Position\n");
	fprintf(g_output_file, "\n");
}

/*
 *.. ᥤ
 */
int		main(int argc, char *argv[])
{
	int		result = 0;

	EB_Character_Code	character_code;
	EB_Subbook_Code		subbook_list[EB_MAX_SUBBOOKS];
    int					subbook_count;

	iconv_t		cd;
	const char	*inbuf_ptr;
	char		*outbuf_ptr;
	size_t		inbytesleft;
	size_t		outbytesleft;

	char	path_work[MAX_PATH_WORK_SIZE];
	int		i;


	global_init();

	if (argc == 1) {
		usage();
		exit(0);
	}
	parse_env();
	parse_option(argc, argv);

	char	search_word_buffer[g_search_word_buffer_size];


	/* -x0 ץ */
	/* եνϡʥǥХåѡ */
	if (g_enable_config_display == TRUE) {
		fprintf(g_output_file, "Output File [%s]\n", (g_output_file == stdout ? "stdout" : g_output_file_path));
		fprintf(g_output_file, "Book Path [%s]\n", g_book_path);
		fprintf(g_output_file, "SubBook Number [%d]\n", g_subbook_number);
		fprintf(g_output_file, "Input Character Encoding [%s]\n", g_encoding_table[g_input_encoding]);
		fprintf(g_output_file, "Output Character Encoding [%s]\n", g_encoding_table[g_output_encoding]);
		fprintf(g_output_file, "Search Method [");
		for (i = 0; i < g_search_method_count; ++i)
			fprintf(g_output_file, "%s%s", (i == 0 ? "" : ","), g_method_table[g_search_method[i]]);
		fprintf(g_output_file, "]\n");
		fprintf(g_output_file, "Text View Setting [%d]\n", g_text_view);
		fprintf(g_output_file, "List View Setting [%d]\n", g_list_view);
		fprintf(g_output_file, "\n");
	}


	fmtout_book_start();


	/*------------    EB LibraryΥåȥå    ------------*/
	if (g_book_path[0] == '\0') {
		fprintf(g_output_file, "Error: Book path not given.\n");
		result = 1;  goto error_exit;
	}

	if (eb_initialize_library() != EB_SUCCESS) {
		fprintf(g_output_file, "Error: eb_initialize_library() failed.\n");
		result = 1;  goto error_exit;
	}
	eb_initialize_book(&g_book_object);
	g_book_object_opend = TRUE;

	path_work[0] = '\0';
#ifdef HAVE_CYGWIN_CONV_TO_POSIX_PATH
	cygwin_conv_to_posix_path(g_book_path, path_work);
#else
	strcpy(path_work, g_book_path);
#endif
	if (eb_bind(&g_book_object, path_work) != EB_SUCCESS) {
		fprintf(g_output_file, "Error: eb_bind() failed.\n");
		result = 1;  goto error_exit;
	}

	if (eb_character_code(&g_book_object, &character_code) != EB_SUCCESS) {
		fprintf(g_output_file, "Error: eb_character_code() failed.\n");
		result = 1;  goto error_exit;
	}
	if (character_code != EB_CHARCODE_JISX0208) {
		fprintf(g_output_file, "Error: Unsupported character code.\n");
		result = 1;  goto error_exit;
	}

    if (eb_subbook_list(&g_book_object, subbook_list, &subbook_count) != EB_SUCCESS) {
		fprintf(g_output_file, "Error: eb_subbook_list() failed.\n");
		result = 1;  goto error_exit;
    }

	if (g_subbook_number > subbook_count) {
		fprintf(g_output_file, "Error: Invalid subbook number.\n");
		result = 1;  goto error_exit;
	}
	if (eb_set_subbook(&g_book_object, subbook_list[g_subbook_number - 1]) != EB_SUCCESS) {
		fprintf(g_output_file, "Error: eb_set_subbook() failed.\n");
		result = 1;  goto error_exit;
	}

	eb_initialize_hookset(&g_hookset_object);
	g_hookset_object_opened = TRUE;
	eb_set_hooks(&g_hookset_object, g_hook_functions);


	/*------------    Υ󥳡ǥѴ    ------------*/
	if (g_input_encoding != ENC_EUCJP) {
		cd = iconv_open(g_encoding_table[ENC_EUCJP], g_encoding_table[g_input_encoding]);
		if (cd == (iconv_t)-1) {
			fprintf(g_output_file, "Error: iconv_open() for input encoding failed.\n");
			result = 1;  goto error_exit;
		}
		g_input_cd = cd;
		g_input_cd_opened = TRUE;

		outbuf_ptr = search_word_buffer;
		outbytesleft = g_search_word_buffer_size - 1;
		for (i = 0; g_search_word_ptr[i] != NULL; ++i) {
			inbuf_ptr = g_search_word_ptr[i];
			inbytesleft = strlen(g_search_word_ptr[i]);
			g_search_word_ptr[i] = outbuf_ptr;
			iconv(g_input_cd, &inbuf_ptr, &inbytesleft, &outbuf_ptr, &outbytesleft);
			*outbuf_ptr++ = '\0';
			--outbytesleft;
		}
	}


	/*------------    ѥ󥳡ǥѴΥåȥå    ------------*/
	if (g_output_encoding != ENC_EUCJP) {
		cd = iconv_open(g_encoding_table[g_output_encoding], g_encoding_table[ENC_EUCJP]);
		if (cd == (iconv_t)-1) {
			fprintf(g_output_file, "Error: iconv_open() for output encoding failed.\n");
			result = 1;  goto error_exit;
		}
		g_output_cd = cd;
		g_output_cd_opened = TRUE;
	}


	/*------------    ¹    ------------*/
	search_main();

	
error_exit:

	fmtout_book_end();


	if (g_input_cd_opened)
		iconv_close(g_input_cd);
	if (g_output_cd_opened)
		iconv_close(g_output_cd);

	if (g_hookset_object_opened)
		eb_finalize_hookset(&g_hookset_object);
	if (g_book_object_opend)
		eb_finalize_book(&g_book_object);
	eb_finalize_library();

	if (g_output_file != stdout)
		fclose(g_output_file);

	return result;
}

